//---------------------------------------------------------------------------
// Copyright (C) 2002 by Dmitry Vassiliev
// slydiman@mail.ru
// http://slydiman.narod.ru
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <malloc.h>
#include <dshow.h>
#include <uuids.h>
#include <dmodshow.h>
#include <dmoreg.h>

#include <mtype.h>   // DirectX BaseClasses

#include "Main.h"

//------------------------------------------------------------------------------
// No need to include strmiids.lib
//
const GUID CLSID_DMOWrapperFilter   = {0x94297043,0xbd82,0x4dfd,{0xb0,0xde,0x81,0x77,0x73,0x9c,0x6d,0x20}};
const GUID IID_IDMOWrapperFilter    = {0x52d6f586,0x9f0f,0x4824,{0x8f,0xc8,0xe3,0x2c,0xa0,0x49,0x30,0xc2}};
const GUID DMOCATEGORY_AUDIO_EFFECT = {0xf3602b3f,0x0592,0x48df,{0xa4,0xcd,0x67,0x47,0x21,0xe7,0xeb,0xeb}};
const GUID TIME_FORMAT_MEDIA_TIME   = {0x7b785574,0x8c82,0x11cf,{0xbc,0x0c,0x00,0xaa,0x00,0xac,0x74,0xf6}};

//------------------------------------------------------------------------------
#define SAFE_RELEASE(p) { if(p) { (p)->Release(); (p)=NULL; } }

#define WM_GRAPHNOTIFY  WM_APP + 1

// DirectShow Graph, Filter & Pins used
IGraphBuilder *g_pGraphBuilder = NULL;
IMediaControl *g_pMediaControl = NULL;
IMediaEventEx *g_pMediaEventEx = NULL;
IMediaSeeking *g_pMediaSeeking = NULL;
IVideoWindow  *g_pVideoWindow  = NULL;
IBasicAudio   *g_pBasicAudio   = NULL;
IBasicVideo   *g_pBasicVideo   = NULL;
IBaseFilter   *g_pSourceCurrent = NULL;
IBaseFilter   *g_pDMOWrapFilter = NULL;
LONGLONG MaxPos = 0;
char MaxPosStr[MAX_PATH];
bool bRender = false;

long VideoWidth  = 350;
long VideoHeight = 200;

#define DMOFILTERNAME TEXT(L"Custom DMO Audio Effect")

#define MAX_NUM 100
// struct holding DMOs registerd as DMOCATGORY_AUDIO_EFFECT
typedef struct tagDMOINFO {
    TCHAR szName[MAX_NUM];
    CLSID clsidDMO;
} DMOINFO;

DMOINFO g_rgDmoInfo[MAX_PATH];

//---------------------------------------------------------------------------
void MediaTimeToStr( char *Str, LONGLONG Pos )
{
  Pos /= 10000000;
  int s = Pos % 60;
  Pos /= 60;
  int m = Pos % 60;
  int h = Pos / 60;
  wsprintf( Str, "%d:%.2d:%.2d", h, m, s );
}

//---------------------------------------------------------------------------
bool InsertDMO( int Index )
{
  // Create the DMO Wrapper filter.
  IPin *pDMOPin1 = NULL;
  IPin *pDMOPin2 = NULL;

  HRESULT hr = CoCreateInstance(CLSID_DMOWrapperFilter, NULL,
                                CLSCTX_INPROC, IID_IBaseFilter, (void **)&g_pDMOWrapFilter);
  if( SUCCEEDED(hr) ){
    IDMOWrapperFilter *pWrap;
    hr = g_pDMOWrapFilter->QueryInterface(IID_IDMOWrapperFilter, (void **)&pWrap);
    if( SUCCEEDED(hr) ){
      hr = pWrap->Init( g_rgDmoInfo[Index].clsidDMO, DMOCATEGORY_AUDIO_EFFECT );
      pWrap->Release();
    }
  }

  if( SUCCEEDED(hr) ){
    IEnumPins *pPinEnum = NULL;
    hr = g_pDMOWrapFilter->EnumPins( &pPinEnum );
    if( SUCCEEDED(hr) ){
      pPinEnum->Reset();
      hr = pPinEnum->Next(1, &pDMOPin1, NULL);
      if( SUCCEEDED(hr) ){
        hr = pPinEnum->Next(1, &pDMOPin2, NULL);
      }
      SAFE_RELEASE(pPinEnum);
    }
    if( SUCCEEDED(hr) ){
      PIN_DIRECTION PinDir;
      pDMOPin1->QueryDirection(&PinDir);
      if( PinDir != PINDIR_INPUT )  hr = E_ABORT;
      if( SUCCEEDED(hr) ){
        pDMOPin2->QueryDirection(&PinDir);
        if( PinDir != PINDIR_OUTPUT )  hr = E_ABORT;
      }
    }
  }

  if( SUCCEEDED(hr) ){
    IBaseFilter *pDSFilter = NULL;
//    hr = g_pGraphBuilder->FindFilterByName( L"Default DirectSound Device", &pDSFilter );

    IEnumFilters *pFilterEnum = NULL;
    hr = g_pGraphBuilder->EnumFilters(&pFilterEnum);
    if( SUCCEEDED(hr) ){
      pFilterEnum->Reset();
      hr = E_ABORT;
      while( S_OK == pFilterEnum->Next(1, &pDSFilter, NULL) ){
        FILTER_INFO FilterInfo;
        pDSFilter->QueryFilterInfo( &FilterInfo );
        if( wcsstr( FilterInfo.achName, L"DirectSound" ) != NULL ){
          hr = S_OK;
          break;
        }
      }
      SAFE_RELEASE(pFilterEnum);
    }

    if( FAILED(hr) ){
      Application->MessageBox( "Can't find DirectSound Renderer", "FilterGraph error", MB_OK | MB_ICONWARNING );

    }else{
      IPin *pDSPin = NULL;
      hr = pDSFilter->FindPin(L"Audio Input pin (rendered)", &pDSPin);
      if( SUCCEEDED(hr) ){
        IPin *pDecPin = NULL;
        hr = pDSPin->ConnectedTo( &pDecPin );
        if( SUCCEEDED(hr) ){
          AM_MEDIA_TYPE mt;
          hr = pDSPin->ConnectionMediaType( &mt );
          if( SUCCEEDED(hr) ){
            hr = g_pGraphBuilder->AddFilter( g_pDMOWrapFilter, DMOFILTERNAME );
            if( SUCCEEDED(hr) ){     // Add the filter to the graph.
              hr = g_pGraphBuilder->Disconnect(pDecPin);
              hr = g_pGraphBuilder->Disconnect(pDSPin);
              hr = g_pGraphBuilder->ConnectDirect( pDecPin, pDMOPin1, &mt );
              if( SUCCEEDED(hr) ){
                hr = g_pGraphBuilder->ConnectDirect( pDMOPin2, pDSPin, &mt );
              }
              if( FAILED(hr) ){
                g_pGraphBuilder->Disconnect(pDecPin);
                g_pGraphBuilder->RemoveFilter( g_pDMOWrapFilter );
//                g_pGraphBuilder->Render(pDecPin);
                g_pGraphBuilder->ConnectDirect( pDecPin, pDSPin, &mt );
              }
            }
            FreeMediaType( mt );
          }
          pDecPin->Release();
        }
        pDSPin->Release();
      }
      pDSFilter->Release();
    }
  }

  SAFE_RELEASE( pDMOPin2 );
  SAFE_RELEASE( pDMOPin1 );

  if( FAILED(hr) )
    SAFE_RELEASE( g_pDMOWrapFilter );

  return SUCCEEDED(hr);
}

//---------------------------------------------------------------------------
void RemoveDMO( void )
{
  if( g_pDMOWrapFilter == NULL )  return;

  IPin *pDMOPin1 = NULL;
  IEnumPins *pPinEnum = NULL;
  HRESULT hr = g_pDMOWrapFilter->EnumPins( &pPinEnum );
  if( SUCCEEDED(hr) ){
    pPinEnum->Reset();
    hr = pPinEnum->Next(1, &pDMOPin1, NULL);
    SAFE_RELEASE(pPinEnum);
  }
  if( SUCCEEDED(hr) ){
    PIN_DIRECTION PinDir;
    pDMOPin1->QueryDirection(&PinDir);
    if( PinDir != PINDIR_INPUT )  hr = E_ABORT;
  }
  IPin *pDecPin = NULL;
  if( SUCCEEDED(hr) ){
    hr = pDMOPin1->ConnectedTo( &pDecPin );
  }
  SAFE_RELEASE(pDMOPin1);
  g_pGraphBuilder->RemoveFilter( g_pDMOWrapFilter );

  SAFE_RELEASE( g_pDMOWrapFilter );

  if( SUCCEEDED(hr) ){
    g_pGraphBuilder->Render( pDecPin );
    SAFE_RELEASE( pDecPin );
  }
}

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TSlyPlayerForm *SlyPlayerForm;

//---------------------------------------------------------------------------
__fastcall TSlyPlayerForm::TSlyPlayerForm(TComponent* Owner) : TForm(Owner)
{
}

//---------------------------------------------------------------------------
void TSlyPlayerForm::ResizeVideoWindow( void )
{
  if( !g_pVideoWindow )  return;

  double w = VideoWindowPanel->Width  - 2;
  double h = VideoWindowPanel->Height - 2;
  if( !VideoWidth || !VideoHeight || !w || ! h )  return;

  long x = 0;
  long y = 0;
  long ww, hh;
  if( (w / VideoWidth) > (h / VideoHeight) ){
    ww = h * VideoWidth / VideoHeight;
    hh = h;
    x = (w - ww)/2;
  }else{
    hh = w * VideoHeight / VideoWidth;
    ww = w;
    y = (h - hh)/2;
  }

  g_pVideoWindow->SetWindowPosition( x+1, y+1, ww, hh );
}

//---------------------------------------------------------------------------
HRESULT TSlyPlayerForm::SetupVideoWindow(void)
{
  HRESULT hr;

  // Set the video window to be a child of the main window
  hr = g_pVideoWindow->put_Owner( (OAHWND)Handle );
  if( FAILED(hr) )  return hr;

  // Set video window style
  hr = g_pVideoWindow->put_WindowStyle(WS_CHILD | WS_CLIPCHILDREN);
  if( FAILED(hr) )  return hr;

  // Use helper function to position video window in client rect
  // of main application window
  ResizeVideoWindow();

  // Make the video window visible, now that it is properly positioned
  hr = g_pVideoWindow->put_Visible(OATRUE);
  if( FAILED(hr) )  return hr;

  hr = g_pVideoWindow->put_MessageDrain( (OAHWND)VideoWindowPanel->Handle );
  if( FAILED(hr) )  return hr;

  return hr;
}

//------------------------------------------------------------------------------
HRESULT GraphInit(void)
{
  // Initialize COM
  HRESULT hr = CoInitialize(NULL);
  if( FAILED(hr) )  return hr;

  // Create DirectShow Graph
  hr = CoCreateInstance(CLSID_FilterGraph, NULL, CLSCTX_INPROC, IID_IGraphBuilder,
                        reinterpret_cast<void **>(&g_pGraphBuilder));
  if( FAILED(hr) )  return hr;

  hr = g_pGraphBuilder->QueryInterface(IID_IMediaControl, reinterpret_cast<void **>(&g_pMediaControl));
  if( FAILED(hr) )  return hr;

  hr = g_pGraphBuilder->QueryInterface(IID_IMediaEventEx, reinterpret_cast<void **>(&g_pMediaEventEx));
  if( FAILED(hr) )  return hr;

  g_pMediaEventEx->SetNotifyWindow( (OAHWND)SlyPlayerForm->Handle, WM_GRAPHNOTIFY, 0 );

  hr = g_pGraphBuilder->QueryInterface(IID_IMediaSeeking, reinterpret_cast<void **>(&g_pMediaSeeking));
  if( FAILED(hr) )  return hr;

  hr = g_pGraphBuilder->QueryInterface(IID_IVideoWindow, (LPVOID *) &g_pVideoWindow);
  if( FAILED(hr) )  return hr;

  hr = g_pGraphBuilder->QueryInterface(IID_IBasicAudio, reinterpret_cast<void **>(&g_pBasicAudio) );
  if( FAILED(hr) )  return hr;

  hr = g_pGraphBuilder->QueryInterface(IID_IBasicVideo, reinterpret_cast<void **>(&g_pBasicVideo) );
  if( FAILED(hr) )  return hr;

  return S_OK;
}

//---------------------------------------------------------------------------
void __fastcall TSlyPlayerForm::FormCreate(TObject *Sender)
{
  if( !SUCCEEDED( GraphInit() ) ){
    Application->MessageBox( "Can't create DirectShow GraphBuilder", "Fatal error", MB_OK | MB_ICONSTOP );
    Application->Terminate();
    return;
  }

  EffectComboBox->Items->Clear();
  EffectComboBox->Items->Add( "<none>" );
  int iNumDmo = InitializeAudioEffectDMOList();
  for( int i = 0; i < iNumDmo; i++ ){
    EffectComboBox->Items->Add( g_rgDmoInfo[i].szName );
  }

  int i = EffectComboBox->Items->IndexOf( "Sly EQ" );
  if( i < 0 )  i = 0;
  EffectComboBox->ItemIndex = i;
  EffectComboBoxChange(NULL);
}

//---------------------------------------------------------------------------
void __fastcall TSlyPlayerForm::FormDestroy(TObject *Sender)
{
  // Stop playback
  if (g_pMediaControl)
      g_pMediaControl->Stop();

  if( g_pMediaEventEx )
      g_pMediaEventEx->SetNotifyWindow( NULL, WM_GRAPHNOTIFY, 0 );

  if( g_pVideoWindow ){
      g_pVideoWindow->put_MessageDrain( (OAHWND)NULL );
      g_pVideoWindow->put_Visible(OAFALSE);
      g_pVideoWindow->put_Owner(NULL);
  }

  // Release all remaining pointers
  SAFE_RELEASE( g_pDMOWrapFilter );
  SAFE_RELEASE( g_pSourceCurrent );
  SAFE_RELEASE( g_pBasicAudio    );
  SAFE_RELEASE( g_pBasicVideo    );  
  SAFE_RELEASE( g_pVideoWindow   );
  SAFE_RELEASE( g_pMediaSeeking  );
  SAFE_RELEASE( g_pMediaEventEx  );
  SAFE_RELEASE( g_pMediaControl  );
  SAFE_RELEASE( g_pGraphBuilder  );

  // Clean up COM
  CoUninitialize();
}

//---------------------------------------------------------------------------
void __fastcall TSlyPlayerForm::FormResize(TObject *Sender)
{
  ResizeVideoWindow();
}

//---------------------------------------------------------------------------
int TSlyPlayerForm::InitializeAudioEffectDMOList( void )
{
  IEnumDMO* pEveryRegisterDMOEnum = NULL;
  HRESULT hrNext;
  DWORD ulNumInfoReturned;
  CLSID clsidCurrentDMO;
  WCHAR* apszDMOName;
  int iNumDmo = 0;

  // Enumerate all the registered DMOs registered as DMOCATEGORY_AUDIO_EFFECT.
  HRESULT hr = DMOEnum( DMOCATEGORY_AUDIO_EFFECT,
                        DMO_ENUMF_INCLUDE_KEYED,
                        0, // Number of input partial media types.
                        NULL,
                        0, // Number of output partial media types.
                        NULL,
                        &pEveryRegisterDMOEnum );

  if( FAILED( hr ) )  return 0;

  do{
    hrNext = pEveryRegisterDMOEnum->Next( 1, &clsidCurrentDMO, &apszDMOName, &ulNumInfoReturned );
    if( FAILED( hrNext ) ) {
      SAFE_RELEASE( pEveryRegisterDMOEnum );
      return iNumDmo;
    }

    if( S_OK == hrNext ){
#ifdef UNICODE
      lstrcpy(g_rgDmoInfo[*iNumDmo].szName,  apszDMOName );
#else
      TCHAR tempStr[MAX_PATH];
      int i = wcstombs(tempStr, apszDMOName, MAX_PATH);
      if( i == -1 ){
        Application->MessageBox( "wcstombs function encountered a wide character that could not be converted to a multibyte character.",
                                 "Error enumerating DMOs", MB_OK | MB_ICONERROR );
        return iNumDmo;
      }
      lstrcpy(g_rgDmoInfo[iNumDmo].szName,  tempStr );
#endif

      CoTaskMemFree( apszDMOName );
      g_rgDmoInfo[iNumDmo].clsidDMO = clsidCurrentDMO;
      iNumDmo++;
    }

  }while( (S_OK == hrNext) && (iNumDmo < MAX_NUM) );

  SAFE_RELEASE( pEveryRegisterDMOEnum );
  return iNumDmo;
}

//---------------------------------------------------------------------------
void __fastcall TSlyPlayerForm::WndProc( Messages::TMessage &Message )
{
  switch( Message.Msg ){

  case WM_GRAPHNOTIFY:
  {
    long evCode, param1, param2;
    HRESULT hr;
    while( hr = g_pMediaEventEx->GetEvent(&evCode, &param1, &param2, 0), SUCCEEDED(hr) ){
      switch(evCode){
      case EC_COMPLETE:
        Stop0Execute(NULL);
        if( Loop0->Checked )  Play0Execute(NULL);
      break;
      }
      hr = g_pMediaEventEx->FreeEventParams(evCode, param1, param2);
    }
    break;
  }

  } // switch

  TForm::WndProc( Message );
}

//---------------------------------------------------------------------------
void __fastcall TSlyPlayerForm::EffectComboBoxChange(TObject *Sender)
{
  DMOSettingsButton->Enabled = (EffectComboBox->ItemIndex > 0);
  if( !bRender )  return;

  OAFilterState pfs;
  if( g_pMediaControl->GetState( 100, &pfs ) != S_OK )  return;
  bool bPlay = (pfs == State_Running);

  g_pMediaControl->Stop();

  LONGLONG Pos = 0;
  g_pMediaSeeking->GetCurrentPosition( &Pos );

  if( g_pDMOWrapFilter )
    RemoveDMO();

  if( EffectComboBox->ItemIndex > 0 )
    InsertDMO( EffectComboBox->ItemIndex - 1 );

  g_pMediaSeeking->SetPositions(&Pos, AM_SEEKING_AbsolutePositioning,
                                &Pos, AM_SEEKING_NoPositioning );

  if( bPlay )
    g_pMediaControl->Run();
}

//---------------------------------------------------------------------------
void __fastcall TSlyPlayerForm::DMOSettingsButtonClick(TObject *Sender)
{
  int i = EffectComboBox->ItemIndex - 1;

  ISpecifyPropertyPages *pProp;
  HRESULT hr;

  if( g_pDMOWrapFilter ){
    hr = g_pDMOWrapFilter->QueryInterface(IID_ISpecifyPropertyPages,
                                          reinterpret_cast<void **>(&pProp) );
  }else{
    hr = CoCreateInstance( g_rgDmoInfo[i].clsidDMO, NULL,
                           CLSCTX_INPROC, IID_ISpecifyPropertyPages,
                           reinterpret_cast<void **>(&pProp) );
  }

  if( SUCCEEDED(hr) ){
    IUnknown *pUnk;
    pProp->QueryInterface(IID_IUnknown, (void **)&pUnk);

    // Show the page.
    CAUUID caGUID;
    pProp->GetPages(&caGUID);

    WCHAR tempStr[MAX_PATH];
    mbstowcs(tempStr, g_rgDmoInfo[i].szName, MAX_PATH);

    OleCreatePropertyFrame(
        this->Handle,               // Parent window
        0, 0,                       // (Reserved)
        tempStr,                    // Caption for the dialog box
        1,                          // Number of objects (just the filter)
        &pUnk,                      // Array of object pointers.
        caGUID.cElems,              // Number of property pages
        caGUID.pElems,              // Array of property page CLSIDs
        0,                          // Locale identifier
        0, NULL                     // Reserved
    );

    CoTaskMemFree(caGUID.pElems);

    // Clean up.
    pUnk->Release();
    pProp->Release();
  }

}

//---------------------------------------------------------------------------
void __fastcall TSlyPlayerForm::FullScreenExecute(TObject *Sender)
{
  if( !g_pVideoWindow )  return;

  long FullScreenMode = 0;
  g_pVideoWindow->get_FullScreenMode( &FullScreenMode );
  FullScreenMode = (FullScreenMode == OAFALSE ? OATRUE : OAFALSE);
  g_pVideoWindow->put_FullScreenMode( FullScreenMode );
}

//---------------------------------------------------------------------------
void __fastcall TSlyPlayerForm::SeekSliderPanelMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  SeekBackPanelMouseDown(Sender,Button,Shift,X+1,Y);
}

//---------------------------------------------------------------------------
void __fastcall TSlyPlayerForm::SeekBackPanelMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  if( !g_pMediaSeeking )  return;

  LONGLONG Pos = MaxPos * (X-1) / (SeekBackPanel->ClientWidth-2);

  g_pMediaSeeking->SetPositions(&Pos, AM_SEEKING_AbsolutePositioning,
                                &Pos, AM_SEEKING_NoPositioning );
}

//---------------------------------------------------------------------------
void __fastcall TSlyPlayerForm::UpdateTimerTimer(TObject *Sender)
{
  if( !g_pMediaSeeking )  return;

  LONGLONG Pos = 0;
  g_pMediaSeeking->GetCurrentPosition( &Pos );

  SeekSliderPanel->Width = Pos * (SeekBackPanel->ClientWidth-2) / MaxPos;

  char CurPosStr[32];
  MediaTimeToStr( CurPosStr, Pos );

  char Str[64];
  wsprintf( Str, "%s / %s", CurPosStr, MaxPosStr );
  StatusBar->SimpleText = Str;
}

//---------------------------------------------------------------------------
void __fastcall TSlyPlayerForm::VolumeTrackBarChange(TObject *Sender)
{
  if( !g_pBasicAudio )  return;

  long lVolume = VolumeTrackBar->Position;
  g_pBasicAudio->put_Volume( -lVolume );
}

//---------------------------------------------------------------------------
void __fastcall TSlyPlayerForm::VideoWindowPanelClick(TObject *Sender)
{
  if( Pause0->Enabled )  Pause0Execute(NULL);
}

//---------------------------------------------------------------------------
void __fastcall TSlyPlayerForm::OpenExecute(TObject *Sender)
{
  if( !g_pMediaControl )  return;

  if( !OpenDialog->Execute() )  return;

  HRESULT hr = S_OK;
  IPin *pPin = NULL;
  WCHAR wFileName[MAX_PATH];

  #ifndef UNICODE
    MultiByteToWideChar(CP_ACP, 0, OpenDialog->FileName.c_str(), -1, wFileName, MAX_PATH);
  #else
    lstrcpy(wFileName, OpenDialog->FileName.c_str());
  #endif

  // Add the new source filter to the graph. (Graph can still be running)
  IBaseFilter *g_pSourceNext = NULL;
  hr = g_pGraphBuilder->AddSourceFilter(wFileName, wFileName, &g_pSourceNext);

  // Get the first output pin of the new source filter. Audio sources
  // typically have only one output pin, so for most audio cases finding
  // any output pin is sufficient.
  if( SUCCEEDED(hr)) {
    hr = g_pSourceNext->FindPin(L"Output", &pPin);

    g_pMediaControl->Stop();

    UpdateTimer->Enabled = false;

//-----------------------------------------------------------------------
    // Break all connections on the filters. You can do this by adding
    // and removing each filter in the graph
    IEnumFilters *pFilterEnum = NULL;

    if( SUCCEEDED(hr = g_pGraphBuilder->EnumFilters(&pFilterEnum)) ){
      int iFiltCount = 0;

      // Need to know how many filters. If we add/remove filters during the
      // enumeration we'll invalidate the enumerator
      while (S_OK == pFilterEnum->Skip(1)) {
        iFiltCount++;
      }

      // Allocate space, then pull out all of the
      IBaseFilter **ppFilters = reinterpret_cast<IBaseFilter **>
                                (alloca(sizeof(IBaseFilter *) * iFiltCount));
      pFilterEnum->Reset();

      int iPos = 0;
      while (S_OK == pFilterEnum->Next(1, &(ppFilters[iPos++]), NULL));
      SAFE_RELEASE(pFilterEnum);

      for( iPos = 0; iPos < iFiltCount; iPos++ ){
        FILTER_INFO FilterInfo;
        ppFilters[iPos]->QueryFilterInfo( &FilterInfo );
        g_pGraphBuilder->RemoveFilter( ppFilters[iPos] );
/*
        // Put the filter back, unless it is the old source or DMO Wrapper
        if( ppFilters[iPos] != g_pSourceCurrent &&
            ppFilters[iPos] != g_pDMOWrapFilter ){
          g_pGraphBuilder->AddFilter(ppFilters[iPos], FilterInfo.achName );
        }
*/
        if( ppFilters[iPos] == g_pSourceNext ){
          g_pGraphBuilder->AddFilter(ppFilters[iPos], FilterInfo.achName );
        }

        SAFE_RELEASE(ppFilters[iPos]);
      }
    }

    // Release the old source filter.
    SAFE_RELEASE(g_pSourceCurrent);
    // Release the DMO Wrapper filter.
    SAFE_RELEASE(g_pDMOWrapFilter);
//-----------------------------------------------------------------------

    // We have the new ouput pin. Render it
    if( SUCCEEDED(hr) ){
      hr = g_pGraphBuilder->Render(pPin);
      g_pSourceCurrent = g_pSourceNext;
    }

    SAFE_RELEASE(pPin);
  }

  if( SUCCEEDED(hr) ){

    if( SUCCEEDED(SetupVideoWindow()) ){
      TitleImage->Enabled = false;
      TitleImage->Visible = false;
      VideoWidth  = 350;
      VideoHeight = 200;
      if( g_pBasicVideo )
          g_pBasicVideo->GetVideoSize( &VideoWidth, &VideoHeight );
      Constraints->MinHeight = 200;
      Height = Height - VideoWindowPanel->Height + VideoHeight + 2;
      ClientWidth = VideoWidth + 2;
    }else{
      VideoWidth  = 0;
      VideoHeight = 0;
      Constraints->MinHeight = Height - VideoWindowPanel->Height;
      Height = Constraints->MinHeight;
      Width = Constraints->MinWidth;
    }

    bRender = true;

    if( EffectComboBox->ItemIndex > 0 ){
      if( !InsertDMO( EffectComboBox->ItemIndex - 1 ) ){
        Application->MessageBox( "Can't insert DMO", "FilterGraph error", MB_OK | MB_ICONWARNING );
      }
    }

    // Re-seek the graph to the beginning
    hr = g_pMediaSeeking->SetTimeFormat( &TIME_FORMAT_MEDIA_TIME );

    LONGLONG Pos = 0;
    hr = g_pMediaSeeking->SetPositions(&Pos, AM_SEEKING_AbsolutePositioning,
                                       &Pos, AM_SEEKING_NoPositioning );

    MaxPos = 0;
    hr = g_pMediaSeeking->GetStopPosition( &MaxPos );

    MediaTimeToStr( MaxPosStr, MaxPos );
    strcat( MaxPosStr, " - " );
    strcat( MaxPosStr, ExtractFileName(OpenDialog->FileName).c_str() );
    if( VideoHeight > 0 )
      wsprintf( MaxPosStr + strlen(MaxPosStr), " - %dx%d", VideoWidth, VideoHeight );

    Play0->Enabled = true;
    Play0Execute(NULL);

    UpdateTimer->Enabled = true;
  }else{
    StatusBar->SimpleText = "Error open file";
  }
}

//---------------------------------------------------------------------------
void __fastcall TSlyPlayerForm::Play0Execute(TObject *Sender)
{
  if( !g_pMediaControl )  return;
  g_pMediaControl->Run();
  Play0->Enabled = false;
  Stop0->Enabled = true;
  Pause0->Enabled = true;
}

//---------------------------------------------------------------------------
void __fastcall TSlyPlayerForm::Stop0Execute(TObject *Sender)
{
  if( !g_pMediaControl )  return;
  g_pMediaControl->Stop();

  LONGLONG Pos = 0;
  g_pMediaSeeking->SetPositions(&Pos, AM_SEEKING_AbsolutePositioning,
                                &Pos, AM_SEEKING_NoPositioning );

  Play0->Enabled = true;
  Stop0->Enabled = false;
  Pause0->Enabled = false;
}

//---------------------------------------------------------------------------
void __fastcall TSlyPlayerForm::Pause0Execute(TObject *Sender)
{
  if( !g_pMediaControl )  return;

  OAFilterState pfs;
  if( g_pMediaControl->GetState( 100, &pfs ) != S_OK )  return;

  if( pfs == State_Paused )
    g_pMediaControl->Run();
  else
    g_pMediaControl->Pause();
}

//---------------------------------------------------------------------------
void __fastcall TSlyPlayerForm::About1Click(TObject *Sender)
{
  Application->MessageBox( "Copyright (C) 2003 Dmitry Vassiliev\nslydiman@mail.ru", "Simply Media Player", MB_OK | MB_ICONINFORMATION );
}

//---------------------------------------------------------------------------
void __fastcall TSlyPlayerForm::Loop0Execute(TObject *Sender)
{
  Loop0->Checked = !Loop0->Checked;
}

//---------------------------------------------------------------------------
void __fastcall TSlyPlayerForm::Zoom1Execute(TObject *Sender)
{
  if( VideoWidth == 0 || VideoHeight == 0 )  return;
  Height = Height - VideoWindowPanel->Height + VideoHeight/2 + 2;
  ClientWidth = VideoWidth/2 + 2;
}

//---------------------------------------------------------------------------
void __fastcall TSlyPlayerForm::Zoom2Execute(TObject *Sender)
{
  if( VideoWidth == 0 || VideoHeight == 0 )  return;
  Height = Height - VideoWindowPanel->Height + VideoHeight + 2;
  ClientWidth = VideoWidth + 2;
}

//---------------------------------------------------------------------------
void __fastcall TSlyPlayerForm::Zoom3Execute(TObject *Sender)
{
  if( VideoWidth == 0 || VideoHeight == 0 )  return;
  Height = Height - VideoWindowPanel->Height + VideoHeight*2 + 2;
  ClientWidth = VideoWidth*2 + 2;
}

//---------------------------------------------------------------------------
void __fastcall TSlyPlayerForm::Exit0Execute(TObject *Sender)
{
  Close();
}

//---------------------------------------------------------------------------

