//---------------------------------------------------------------------------
#ifndef MainH
#define MainH

//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Dialogs.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
#include <Graphics.hpp>
#include <ActnList.hpp>
#include <Menus.hpp>

//---------------------------------------------------------------------------
class TSlyPlayerForm : public TForm
{
__published:	// IDE-managed Components
        TOpenDialog *OpenDialog;
        TTimer *UpdateTimer;
        TStatusBar *StatusBar;
        TPanel *ControlMainPanel;
        TPanel *ControlPanel;
        TLabel *DMOAudEffLabel;
        TPanel *SeekMainPanel;
        TPanel *SeekBackPanel;
        TPanel *SeekSliderPanel;
        TComboBox *EffectComboBox;
        TBitBtn *DMOSettingsButton;
        TBitBtn *PauseButton;
        TBitBtn *StopButton;
        TBitBtn *PlayButton;
        TBitBtn *OpenButton;
        TCheckBox *LoopCheckBox;
        TTrackBar *VolumeTrackBar;
        TPanel *VideoWindowPanel;
        TImage *TitleImage;
        TActionList *ActionList1;
        TAction *FullScreen;
        TAction *Open;
        TMainMenu *MainMenu1;
        TMenuItem *File1;
        TMenuItem *Open1;
        TMenuItem *N1;
        TAction *Exit0;
        TMenuItem *View1;
        TMenuItem *Help1;
        TMenuItem *Exit1;
        TAction *Play0;
        TAction *Stop0;
        TAction *Pause0;
        TMenuItem *Playback1;
        TMenuItem *Play1;
        TMenuItem *Pause1;
        TMenuItem *Stop1;
        TMenuItem *FullScreen1;
        TMenuItem *N2;
        TAction *Zoom1;
        TAction *Zoom2;
        TAction *Zoom3;
        TMenuItem *Zoom501;
        TMenuItem *Zoom1001;
        TMenuItem *Zoom2001;
        TMenuItem *About1;
        TAction *Loop0;
        TMenuItem *N3;
        TMenuItem *Loop1;
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall FormDestroy(TObject *Sender);
        void __fastcall UpdateTimerTimer(TObject *Sender);
        void __fastcall EffectComboBoxChange(TObject *Sender);
        void __fastcall DMOSettingsButtonClick(TObject *Sender);
        void __fastcall SeekBackPanelMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall SeekSliderPanelMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall VolumeTrackBarChange(TObject *Sender);
        void __fastcall FormResize(TObject *Sender);
        void __fastcall FullScreenExecute(TObject *Sender);
        void __fastcall VideoWindowPanelClick(TObject *Sender);
        void __fastcall OpenExecute(TObject *Sender);
        void __fastcall Play0Execute(TObject *Sender);
        void __fastcall Stop0Execute(TObject *Sender);
        void __fastcall Pause0Execute(TObject *Sender);
        void __fastcall About1Click(TObject *Sender);
        void __fastcall Loop0Execute(TObject *Sender);
        void __fastcall Zoom1Execute(TObject *Sender);
        void __fastcall Zoom3Execute(TObject *Sender);
        void __fastcall Zoom2Execute(TObject *Sender);
        void __fastcall Exit0Execute(TObject *Sender);
private:	// User declarations
        void __fastcall WndProc( Messages::TMessage &Message );
        void ResizeVideoWindow(void);
        HRESULT SetupVideoWindow(void);
        int InitializeAudioEffectDMOList( void );
public:		// User declarations
        __fastcall TSlyPlayerForm(TComponent* Owner);
};

//---------------------------------------------------------------------------
extern PACKAGE TSlyPlayerForm *SlyPlayerForm;

//---------------------------------------------------------------------------
#endif
